
-- Create Copy tables

-- Suppress Warnings

DROP TABLE CUSTOMERS_C PURGE;

DROP TABLE SUPPLEMENTARY_DEMOGRAPHICS_C PURGE;

DROP TABLE SALES_C PURGE;

-- End Suppress Warnings


CREATE TABLE CUSTOMERS_C
  (
    CUST_ID                NUMBER NOT NULL ENABLE,
    CUST_FIRST_NAME        VARCHAR2(20) NOT NULL ENABLE,
    CUST_LAST_NAME         VARCHAR2(40) NOT NULL ENABLE,
    CUST_GENDER            CHAR(1) NOT NULL ENABLE,
    CUST_YEAR_OF_BIRTH     NUMBER(4,0) NOT NULL ENABLE,
    CUST_MARITAL_STATUS    VARCHAR2(20),
    CUST_STREET_ADDRESS    VARCHAR2(40) NOT NULL ENABLE,
    CUST_POSTAL_CODE       VARCHAR2(10) NOT NULL ENABLE,
    CUST_CITY              VARCHAR2(30) NOT NULL ENABLE,
    CUST_CITY_ID           NUMBER NOT NULL ENABLE,
    CUST_STATE_PROVINCE    VARCHAR2(40) NOT NULL ENABLE,
    CUST_STATE_PROVINCE_ID NUMBER NOT NULL ENABLE,
    COUNTRY_ID             NUMBER NOT NULL ENABLE,
    CUST_MAIN_PHONE_NUMBER VARCHAR2(25) NOT NULL ENABLE,
    CUST_INCOME_LEVEL      VARCHAR2(30),
    CUST_CREDIT_LIMIT      NUMBER,
    CUST_EMAIL             VARCHAR2(50),
    CUST_TOTAL             VARCHAR2(14) NOT NULL ENABLE,
    CUST_TOTAL_ID          NUMBER NOT NULL ENABLE,
    CUST_SRC_ID            NUMBER,
    CUST_EFF_FROM          DATE,
    CUST_EFF_TO            DATE,
    CUST_VALID             VARCHAR2(1)
) TABLESPACE &tablespace &usecompression INITRANS 32 STORAGE (INITIAL 64M NEXT 64M);


CREATE TABLE SUPPLEMENTARY_DEMOGRAPHICS_C
  (
    CUST_ID                 NUMBER NOT NULL ENABLE,
    EDUCATION               VARCHAR2(21),
    OCCUPATION              VARCHAR2(21),
    HOUSEHOLD_SIZE          VARCHAR2(21),
    YRS_RESIDENCE           NUMBER,
    AFFINITY_CARD           NUMBER(10,0),
    BULK_PACK_DISKETTES     NUMBER(10,0),
    FLAT_PANEL_MONITOR      NUMBER(10,0),
    HOME_THEATER_PACKAGE    NUMBER(10,0),
    BOOKKEEPING_APPLICATION NUMBER(10,0),
    PRINTER_SUPPLIES        NUMBER(10,0),
    Y_BOX_GAMES             NUMBER(10,0),
    OS_DOC_SET_KANJI        NUMBER(10,0),
    COMMENTS                VARCHAR2(4000)
) TABLESPACE &tablespace &usecompression INITRANS 32 STORAGE (INITIAL 64M NEXT 64M);


CREATE TABLE SALES_C
  (
    PROD_ID            NUMBER NOT NULL ENABLE,
    CUST_ID            NUMBER NOT NULL ENABLE,
    TIME_ID            DATE NOT NULL ENABLE,
    CHANNEL_ID         NUMBER NOT NULL ENABLE,
    PROMO_ID           NUMBER NOT NULL ENABLE,
    QUANTITY_SOLD      NUMBER(10,2) NOT NULL ENABLE,
    SELLER             NUMBER(6) NOT NULL ENABLE,
    FULFILLMENT_CENTER NUMBER(6) NOT NULL ENABLE,
    COURIER_ORG        NUMBER(6) NOT NULL ENABLE,
    TAX_COUNTRY        VARCHAR2(3) NOT NULL ENABLE,
    TAX_REGION         VARCHAR2(3),
    AMOUNT_SOLD        NUMBER(10,2) NOT NULL ENABLE
) TABLESPACE &tablespace &usecompression INITRANS 32 STORAGE (INITIAL 64M NEXT 64M); 

-- End;
 
